---
title: Firefox 56 for developers
slug: Mozilla/Firefox/Releases/56
tags:
  - '56'
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div><article class="text-content" id="wikiArticle">
<p class="summary">Firefox 56 was released on September 28, 2017. This article lists key changes that are useful for web developers.</p>

<article class="text-content" id="wikiArticle">
<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>Display Negative Line Numbers in CSS Grid Inspector ({{bug(1369942)}}).</li>
 <li>The new CSS Grid Layout Panel is now available, allowing much better CSS Grid debugging facilities ({{bug(1181227)}}). See <a href="https://hacks.mozilla.org/2017/06/new-css-grid-layout-panel-in-firefox-nightly/">Powerful New Additions to the CSS Grid Inspector in Firefox Nightly</a> for more details.</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Implemented the <code>labels</code> property for labelable form controls, for example {{domxref("HTMLInputElement.labels")}} ({{bug(556743)}}).</li>
 <li>Implemented <code>&lt;link rel="preload"&gt;</code>; see <a href="/en-US/docs/Web/HTML/Preloading_content">Preloading content with rel="preload"</a> for more details ({{bug(1222633)}}). Note that currently Firefox only supports preloading of cacheable resources.</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Implemented the proprietary Mozilla-specific {{cssxref("&lt;color&gt;")}} values <code>-moz-win-accentcolor</code> and <code>-moz-win-accentcolortext</code> (see {{bug(1344910)}}), and the proprietary media query <code><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#-moz-windows-accent-color-in-titlebar">-moz-windows-accent-color-in-titlebar</a></code> (see {{bug(1379938)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl">Intl API</a> has been enabled on Firefox for Android ({{bug(1344625)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<p><em>No changes.</em></p>

<h4 id="DOM">DOM</h4>

<ul>
 <li>On Mac, {{domxref("Document.hidden")}} is now true when the window is behind another non-translucent application {{bug(1236512)}}.</li>
 <li>The {{domxref("Gamepad.displayId")}} property has been implemented ({{bug(1375816)}}).</li>
 <li>The {{domxref("PerformanceTiming.secureConnectionStart")}} property has been implemented ({{bug(772589)}}).</li>
 <li>Firefox used to accept <code>iso-2022-jp-2</code> sequences silently when an <code>iso-2022-jp</code> {{domxref("TextDecoder.TextDecoder","TextDecoder()")}} was instantiated, however this has now been removed to simplify the API, as no other browsers support it and no pages seem to use it. ({{bug(715833)}}).</li>
 <li>The 4ms clamping behaviour of {{domxref("WindowOrWorkerGlobalScope.setTimeout","setTimeout()")}} and {{domxref("WindowOrWorkerGlobalScope.setInterval","setInterval()")}} has been updated to be more in line with other browsers, as described in <a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/setTimeout#Timeouts_throttled_to_%3E4ms">Timeouts throttled to &gt;=4ms</a> ({{bug(1378586)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Page_Visibility_API">Page Visibility API's</a> {{domxref("Document.onvisibilitychange")}} handler has been added ({{bug("1333912")}}).</li>
 <li>The {{domxref("Window.showModalDialog()")}} method has been removed ({{bug(981796)}}).</li>
 <li>The implementation of the {{domxref("HTMLFormElement.action")}}, {{domxref("HTMLInputElement.formAction")}}, and {{domxref("HTMLButtonElement.formAction")}} properties has been updated so that they return the correct form submission URL, as per spec ({{bug(1366361)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>{{domxref("GlobalEventHandlers.onwheel")}} is now available on {{domxref("HTMLElement")}} — it wasn't before ({{bug(1370550)}}).</li>
</ul>

<h4 id="Media_and_WebRTC">Media and WebRTC</h4>

<ul>
 <li>Firefox now supports the {{domxref("RTCPeerConnection")}} properties which let you examine the current and pending configurations of the local and remote ends of the connection, to help manage changes in configuration: {{domxref("RTCPeerConnection.currentLocalDescription", "currentLocalDescription")}}, {{domxref("RTCPeerConnection.pendingLocalDescription", "pendingLocalDescription")}}, {{domxref("RTCPeerConnection.currentRemoteDescription", "currentRemoteDescription")}}, and {{domxref("RTCPeerConnection.pendingRemoteDescription", "pendingRemoteDescription")}}.</li>
 <li>Hardware encoding of media is now enabled by default on Android; it was available but disabled by default in Firefox 55 ({{bug(1386974)}}). This supports higher-efficiency encoding of VP8 media on devices that provide support for it. This saves battery life and processor power, generally improving the performance of the user's device.</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>The {{domxref("CanvasRenderingContext2D.drawImage()")}} method has been updated so that smoothing occurs when downscaling even if <code>imageSmoothingEnabled</code> is <code>false</code>. This is not mandatory as per spec, but follows Chrome's behaviour. See {{bug(1360415)}}.</li>
 <li>An {{domxref("SVGImageElement")}} can now be used as a {{domxref("CanvasImageSource")}}, e.g. as the image source in a {{domxref("CanvasRenderingContext2D.drawImage","drawImage()")}} call ({{bug(1382027)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<p><em>No changes.</em></p>

<h3 id="Plugins">Plugins</h3>

<ul>
 <li>Firefox for Android has removed all support for plugins (<a class="external external-icon" href="https://bugzilla.mozilla.org/show_bug.cgi?id=1381916" title="FIXED: Remove support for plugins (flash)">bug 1381916</a>).</li>
</ul>

<h3 id="Other">Other</h3>

<ul>
 <li>Gecko now encodes URLs internally as <a href="https://en.wikipedia.org/wiki/Punycode">punycode</a>, to avoid URL encoding problems (see {{bug("945240")}}, also see discussion in {{bug("942074")}}).</li>
 <li>Firefox on Windows and Mac OS X can now be made to run in <a href="/en-US/docs/Mozilla/Firefox/Headless_mode">headless mode</a> using the <code>-headless</code> flag (see {{bug(1355150)}} and {{bug(1355147)}}).</li>
</ul>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="HTML_2">HTML</h3>

<ul>
 <li>The {{htmlelement("isindex")}} element has been removed from the HTML parser, and from form submission ({{bug(1266495)}}).</li>
 <li>The {{htmlelement("applet")}} element has been removed ({{bug(1279218)}}).</li>
</ul>

<h3 id="APIs_2">APIs</h3>

<p><em>No changes.</em></p>

<h3 id="SVG_2">SVG</h3>

<p><em>No changes.</em></p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData/RemovalOptions">browsingData.RemovalOptions</a> gets "hostnames" option for cookies</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData/settings">browsingData.settings()</a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browsingData/removeCookies">browsingData.removeCookies() </a>are now supported on Firefox for Android</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/cacheEnabled">browserSettings.cacheEnabled</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/user_interface/Browser_styles">browser_style</a> usage is changed</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/manifest.json/chrome_settings_overrides">chrome_settings_overrides.search_provider.is_default</a></li>
 <li>contextMenus renamed to <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/menus">menus</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/cookies/set">cookies.set()</a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/cookies/remove">cookies.remove()</a> now work in private browsing mode</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/devtools.panels/ElementsPanel/onSelectionChanged">devtools.panels.elements.onSelectionChanged</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/downloads/open">downloads.open()</a> can now only be called from a user action</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/proxy#PAC_file_environment">FindProxyForURL "DIRECT" return type no longer takes an argument</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/history/onVisited">history.onVisited</a> now includes the page title if it is known.</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/management/get">management.get()</a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/management/getAll">management.getAll()</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/menus">menus</a> now supports the "tools_menu" context</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/menus/OnClickData">menus.OnClickData</a> now has "linkText"</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/menus/create">menus.create()</a> now has an <a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/menus#Icons">"icons" option</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/notifications/onShown">notifications.onShown</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/pageAction/show">pageAction.show()</a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/pageAction/hide">pageAction.hide()</a> are now supported on Firefox for Android</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/permissions">permissions</a> now supports "unlimitedStorage"</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/privacy/services">privacy.services</a> now includes passwordSavingEnabled</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/privacy/websites">privacy.websites.referrersEnabled</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/protocol_handlers">protocol_handlers</a> now supports "gopher"</li>
 <li>proxy.<span id="compatNote_1">registerProxyScript() is renamed to <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/proxy/register">proxy.register()</a></span></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/proxy/unregister">proxy.unregister()</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/runtime/onInstalled">runtime.onInstalled</a> gets <code>temporary</code> flag</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/print">tabs.print()</a>, <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/PageSettings">tabs.PageSettings</a>, <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/printPreview">tabs.printPreview()</a>, <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/saveAsPDF">tabs.saveAsPDF()</a></li>
 <li><a href="/en-US/Add-ons/WebExtensions/API/tabs/Tab">tabs.Tab.lastAccessed</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/theme/reset">theme.reset()</a></li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/windows/create">windows.create()</a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/windows/update">windows.update()</a> now support prefacing window title</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/56">Site Compatibility for Firefox 56</a></li>
</ul>
</article>

<ul>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(55)}}</p>
</article>
